(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function get(obj, path) {
        var target = obj;
        try {
            path.forEach(function (key, index) {
                target = target[key];
            });
        }
        catch (e) {
            return undefined;
        }
        return target;
    }
    exports.get = get;
    function set(obj, path, value) {
        if (!obj) {
            obj = isNaN(+path[0]) ? {} : [];
        }
        var target = obj;
        path.forEach(function (key, index) {
            if (index === path.length - 1) {
                target[key] = value;
            }
            else if (!target[key] || typeof target[key] !== 'object') {
                if (isNaN(+path[index + 1])) {
                    target[key] = {};
                }
                else {
                    target[key] = [];
                }
            }
            target = target[key];
        });
        return obj;
    }
    exports.set = set;
});
//# sourceMappingURL=MirrorUtil.js.map